package javax.swing.plaf.basic;

import java.awt.Insets;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.Component;
import java.io.Serializable;
import java.awt.LayoutManager;

class CenterLayout implements LayoutManager, Serializable
{
    CenterLayout() {
    }
    
    @Override
    public void addLayoutComponent(String s, Component component) {
    }
    
    @Override
    public void removeLayoutComponent(Component component) {
    }
    
    @Override
    public Dimension preferredLayoutSize(Container container) {
        Component component = container.getComponent(0);
        if (component != null) {
            Dimension preferredSize = component.getPreferredSize();
            Insets insets = container.getInsets();
            return new Dimension(preferredSize.width + insets.left + insets.right, preferredSize.height + insets.top + insets.bottom);
        }
        return new Dimension(0, 0);
    }
    
    @Override
    public Dimension minimumLayoutSize(Container container) {
        return this.preferredLayoutSize(container);
    }
    
    @Override
    public void layoutContainer(Container container) {
        if (container.getComponentCount() > 0) {
            Component component = container.getComponent(0);
            Dimension preferredSize = component.getPreferredSize();
            int width = container.getWidth();
            int height = container.getHeight();
            Insets insets = container.getInsets();
            component.setBounds((width - (insets.left + insets.right) - preferredSize.width) / 2 + insets.left, (height - (insets.top + insets.bottom) - preferredSize.height) / 2 + insets.top, preferredSize.width, preferredSize.height);
        }
    }
}
